(define atomformel-matchen
  (lambda (atomformel1 atomformel2 sc fc)
    (if (praedikatensymbol=? (atomformel->praedikatensymbol atomformel1)
                             (atomformel->praedikatensymbol atomformel2))
        (terme-matchen (atomformel->terme atomformel1)
                       (atomformel->terme atomformel2)
                       leere-substitution
                       sc
                       fc)
        (fc))))

(define terme-matchen
  (lambda (terme1 terme2 substitution sc fc)
    (cond ((and (null? terme1) (null? terme2)) (sc substitution))
          ((or (null? terme1) (null? terme2)) (fc))
          (else (term-matchen (car terme1)
                              (car terme2)
                              substitution
                              (lambda (neue-substitution)
                                (terme-matchen (cdr terme1) (cdr terme2) neue-substitution sc fc))
                              fc)))))

(define term-matchen
  (lambda (term1 term2 substitution sc fc)
    (if (variable? term1)
        (variable-matchen term1 term2 substitution sc fc)
        (funktion-matchen term1 term2 substitution sc fc))))

(define variable-matchen
  (lambda (variable term substitution sc fc)
    (wert-von variable substitution
                      (lambda (wert) (funktion-matchen wert term substitution sc fc))
                      (lambda () (sc (substitution-erweitern variable term substitution))))))

(define funktion-matchen
  (lambda (funktion1 funktion2 substitution sc fc)
    (if (funktionssymbol=? (funktion->funktionssymbol funktion1)
                           (funktion->funktionssymbol funktion2))
        (terme-matchen (funktion->terme funktion1)
                       (funktion->terme funktion2)
                       substitution sc fc)
        (fc))))
