(define spezifikation=?
  (lambda (spezifikation1 spezifikation2)
    (listen-gleich-mit? regel=?
                        (spezifikation->regeln spezifikation1)
                        (spezifikation->regeln spezifikation2))))

(define regel=?
  (lambda (regel1 regel2)
    (and (rumpf=? (regel->rumpf regel1) (regel->rumpf regel2))
         (kopf=?  (regel->kopf  regel1) (regel->kopf  regel2)))))

(define rumpf=?
  (lambda (rumpf1 rumpf2)
    (listen-gleich-mit? atomformel=?
                        (rumpf->atomformeln rumpf1)
                        (rumpf->atomformeln rumpf2))))
(define kopf=?
  (lambda (kopf1 kopf2)
    (listen-gleich-mit? atomformel=?
                        (kopf->atomformeln kopf1)
                        (kopf->atomformeln kopf2))))

(define atomformel=?
  (lambda (atomformel1 atomformel2)
    (and (praedikatensymbol=? (atomformel->praedikatensymbol atomformel1)
                              (atomformel->praedikatensymbol atomformel2))
         (listen-gleich-mit? term=?
                             (atomformel->terme atomformel1)
                             (atomformel->terme atomformel2)))))

(define praedikatensymbol=?
  (lambda (praedikatensymbol1 praedikatensymbol2)
    (string=? (praedikatensymbol->bezeichner praedikatensymbol1)
              (praedikatensymbol->bezeichner praedikatensymbol2))))

(define praedikatensymbol<?
  (lambda (praedikatensymbol1 praedikatensymbol2)
    (string<? (praedikatensymbol->bezeichner praedikatensymbol1)
              (praedikatensymbol->bezeichner praedikatensymbol2))))

(define variable=?
  (lambda (variable1 variable2)
    (string=? (variable->bezeichner variable1)
              (variable->bezeichner variable2))))

(define funktion=?
  (lambda (funktion1 funktion2)
    (and (funktionssymbol=? (funktion->funktionssymbol funktion1)
                            (funktion->funktionssymbol funktion2))
         (listen-gleich-mit? term=?
                             (funktion->terme funktion1)
                             (funktion->terme funktion2)))))

(define funktionssymbol=?
  (lambda (funktionssymbol1 funktionssymbol2)
    (string=? (funktionssymbol->bezeichner funktionssymbol1)
              (funktionssymbol->bezeichner funktionssymbol2))))

(define term=?
  (lambda (term1 term2)
    (or (and (variable? term1) (variable? term2) (variable=? term1 term2))
        (and (funktion? term1) (funktion? term2) (funktion=? term1 term2)))))
